
__kernel void mmul(
    const int N,
    __global float4* A,
    __global float4* B,
    __global float4* C)
{
uint j = get_global_id (0);
uint i = get_global_id (1);
uint nv4 = N >> 2;
if ((i < N) && (j < nv4))
    {
float4 accum = ( float4 ) 0.0;
for ( uint k = 0; k < nv4 ; ++k)
		   {
		   float4 a = A[i*nv4 + k];
		   float4 b0 = B[(4*k +0)* nv4 + j];
		   float4 b1 = B[(4*k +1)* nv4 + j];
		   float4 b2 = B[(4*k +2)* nv4 + j];
		   float4 b3 = B[(4*k +3)* nv4 + j];
		   accum += a.s0*b0+a.s1*b1+a.s2*b2+a.s3*b3;
		   }
		   C[i*nv4 + j] = accum;
}
}
