
__kernel void mmul(
    const int N,
    __global float* A,
    __global float* B,
    __global float* C)
{
uint j = get_global_id (0);
uint i = get_global_id (1);
uint nv4 = N >> 2;
if ((i < N) && (j < nv4))
    {
float4 accum = ( float4 ) 0.0;
for ( uint k = 0; k < nv4 ; ++k)
		   {
		   float4 a = vload4(0,&A[i*nv4 + k]);
		   float4 b0 = vload4(0,&B[(4*k +0)* nv4 + j]);
		   float4 b1 = vload4(0,&B[(4*k +1)* nv4 + j]);
		   float4 b2 = vload4(0,&B[(4*k +2)* nv4 + j]);
		   float4 b3 = vload4(0,&B[(4*k +3)* nv4 + j]);
		   accum += a.s0*b0+a.s1*b1+a.s2*b2+a.s3*b3;
		   }
		   vstore4(accum,i*nv4 + j,C);
}
}
